/***************************************************************************************\

Module Name:    MtxVer.h

Description:    Definition for MtxVxd version functions.

References:     None.

    Copyright (c) 2000, Matrox Graphics Inc.
    All Rights Reserved.

\***************************************************************************************/

#ifndef INC_MTXVER_H
#define INC_MTXVER_H

// --------------------------------------------------------------------------------------
//                      H E A D E R   F I L E S   R E Q U I R E D
// --------------------------------------------------------------------------------------

#include "MtxType.h"

// --------------------------------------------------------------------------------------
//                           T Y P E   D E F I N I T I O N S
// --------------------------------------------------------------------------------------

typedef struct _MTXVERSIONINFO {

    DWORD dwOSPlatform;
    DWORD dwOSVersion;
    DWORD dwDLLVersion;
    
} MTXVERSIONINFO;

// --------------------------------------------------------------------------------------
//                                  C O N S T A N T S
// --------------------------------------------------------------------------------------
#define MTXVER_PLATFORM_WIN31       1
#define MTXVER_PLATFORM_WIN9X       2
#define MTXVER_PLATFORM_WINNT       4
#define MTXVER_VERSION_RETAIL       1
#define MTXVER_VERSION_OSR2         2
#define MTXVER_VERSION_OSR21        4
#define MTXVER_VERSION_WIN98        8
#define MTXVER_VERSION_NT351        1
#define MTXVER_VERSION_NT4          2
#define MTXVER_VERSION_WIN2K        4
#define MTXVER_VERSION_WIN32S       1

// --------------------------------------------------------------------------------------
//                  G L O B A L   V A R I A B L E   R E F E R E N C E S
// --------------------------------------------------------------------------------------

// --------------------------------------------------------------------------------------
//               I N T E R F A C E   F U N C T I O N   P R O T O T Y P E S
// --------------------------------------------------------------------------------------

EXTERN_C DWORD MtxVxdGetVersionInfo(
    MTXVERSIONINFO* pInfo);

// --------------------------------------------------------------------------------------
//                           I N L I N E S   A N D   M A C R O S
// --------------------------------------------------------------------------------------

#endif  // #ifndef INC_MTXVER_H
